#include "pr4f.h"
int main(int argc, char **argv)
{
  char (*names)[11],*value,type,tstrn[10000];
  int *dl,i,j,s=-1,a=-1,ntaxa=-1,pd,nd,s_in_dl,p,join,k,found_a;
  double *utreec,x=-1.0,l=-1.0,ta;
  
  /* process argument list */
  for(i=1; i<argc; i++){
    type = '\0';
    if(argv[i][0]=='-'){
      if(argv[i][2] != '\0') value = &argv[i][2];
      if(argv[i][2] == '\0') value = argv[(i+1)];
      type = argv[i][1];
    }

    if(type != '\0'){
      if(type=='s') s=atoi(value); 
      if(type=='a') a=atoi(value);
      if(type=='x') x=atof(value);
      if(type=='l') l=atof(value);
      if(type=='n') ntaxa=atoi(value);
    }
  }
  if(s < 0){
    printf("split of interest needs specification with -s edge_label \n");
    exit(1);
  }
  if(a < 0){
    printf("edge to add to must be specified with -a edge_label\n");
    exit(1);
  }
  if(x < 0.0){
    printf("fraction along edge for addition must be specified with -x fraction\n");
    exit(1);
  }
  if(l < 0.0){
    printf("length of new edge must be specified with -l length\n");
    exit(1);
  }
  if(ntaxa < 0){
    printf("number of taxa must be specified with -n number");
    exit(1);
  }
 
  names = (char (*)[11]) malloc((size_t) (ntaxa+1)*sizeof(*names));
  dl = (int *) malloc((size_t) 2*(ntaxa-1)*sizeof(int));
  utreec = (double *) malloc((size_t) 4*ntaxa*sizeof(double));
  
  read_treecsnl(stdin,ntaxa,names,utreec,0);  

  /* pr_utreec(stdout,ntaxa,utreec); */

  /*------------------------------------------------------*/
  if(a >= ntaxa){ /* add to internal edge */
    /* check descendant list of a for s: set s_in_dl */
    pd=0; nd=2; s_in_dl=0;
    dl[0]=utreec[(a-ntaxa)*4]; dl[1]=utreec[1+(a-ntaxa)*4];
    while(pd < nd){
      p=dl[pd];
      if(p > ntaxa){
	dl[nd]=utreec[(p-ntaxa)*4]; dl[nd+1]=utreec[1+(p-ntaxa)*4];
	nd += 2;
      }
      pd++;
    }
    for(i=0; i<nd; i++) 
      if(dl[i]==s){
	s_in_dl=1;
	break;
      }

    /* set each internal edge label to 1 + what it was */
    for(join=0; join<ntaxa-1; join++)
      for(k=0; k<2; k++)
	if(utreec[k+join*4]>=ntaxa) utreec[k+join*4]++;
    a++;
    
    /* find ta and adjust new ancestral edge */
    found_a=0;
    for(join=0; join<ntaxa-1; join++){
      for(k=0; k<2; k++)
	if(utreec[k+join*4]==a){
	  found_a=1;
	  break;
	}
      if(found_a) break;
    }
    ta=utreec[k+2+join*4];
    if(s_in_dl)
      utreec[k+2+join*4]=ta*x;
    else
      utreec[k+2+join*4]=ta*(1-x);
    
    /* adjust labels as large or larger than a upwards */
    for(join=0; join<ntaxa-1; join++)
      for(k=0; k<2; k++)
	if(utreec[k+join*4]>=a) utreec[k+join*4]++;

    /* make room for new join */
    for(join=ntaxa-2; join>=a-ntaxa; join--)
      memcpy(&utreec[(join+1)*4],&utreec[join*4],4*sizeof(double));

    /* new join */
    utreec[(a-ntaxa)*4]=ntaxa;
    utreec[1+(a-ntaxa)*4]=a;
    utreec[2+(a-ntaxa)*4]=l;
    if(s_in_dl)
      utreec[3+(a-ntaxa)*4]=(1-x)*ta;
    else
      utreec[3+(a-ntaxa)*4]=x*ta;
  } /* end of add to internal edge */
  /*------------------------------------------------------*/
  if(a < ntaxa){/* add to terminal edge */
    /* increase internal edge labels by 2 */
    for(join=0; join<ntaxa-1; join++)
      for(k=0; k<2; k++)
	if(utreec[k+join*4]>=ntaxa) utreec[k+join*4] += 2;

    /* find ta and adjust new ancestral edge */
    found_a=0;
    for(join=0; join<ntaxa-1; join++){
      for(k=0; k<2; k++){
	if(((int) utreec[k+join*4])==a){
	  found_a=1;
	  break;
	}
      }
      if(found_a) break;
    }
    /* printf("\n"); */
    /* pr_utreec(stdout,ntaxa,utreec); */
    /* printf("\n%i %i\n",join,k); */
    utreec[k+join*4]=ntaxa+1;
    ta=utreec[k+2+join*4];
    utreec[k+2+join*4]=(1-x)*ta;
    if(k==0 && utreec[1+join*4]<ntaxa){ /* enforce r < l */
      utreec[join*4]=utreec[1+join*4];
      utreec[2+join*4]=utreec[3+join*4];
      utreec[1+join*4]=ntaxa+1; utreec[3+join*4]=(1-x)*ta;
    }
    /* pr_utreec(stdout,ntaxa,utreec); */
    /* printf("\n"); */

    for(join=ntaxa-2; join>=0; join--) 
      memcpy(&utreec[(join+1)*4],&utreec[join*4],4*sizeof(double));

    /* new join */
    utreec[0]=a; utreec[1]=ntaxa; utreec[2]=x*ta; utreec[3]=l;
  }/* end of add to terminal edge */
  /*------------------------------------------------------*/

  /* name of new branch is ntaxa+1 */
  sprintf(names[ntaxa],"%i",ntaxa+1);
  for(i=0; i<10; i++)
    if(names[ntaxa][i]=='\0') break;
  for(j=i; j<10; j++) names[ntaxa][j]=' ';
  names[ntaxa][10]='\0';

  /* pr_utreec(stdout,ntaxa+1,utreec); */
  
  ntaxa++;
  ut2n(ntaxa,utreec,names,tstrn);

  fprintf(stdout,"%s\n",tstrn);
  return(0);
}
