#include "pr4f.h"
int main(int argc, char **argv){
  FILE *paramfile,*treefile,*frfile,*Qfile,*ratefile,*seqfile,*utreecfile;
  char aaRmat[80],(*names)[11];
  int ntaxa,nchar,model,tinfo,ncatG,nrate,nsim,iseed,nsite,soi,i,j,smodel;
  int condl,mid,*seq,has_names=0,fso;
  double kappa,alpha,*fr,*Qk,*rate,*wt,one=1.0,*utreec,*outreec,pr,tm;

  paramfile=fopen(argv[--argc],"r");
  pr4design_paramf(paramfile,&utreecfile,&treefile,&frfile,&Qfile,&ratefile,
		   &seqfile,aaRmat,&ntaxa,&nchar,&model,&ncatG,&nrate,&tinfo,
		   &nsim,&iseed,&nsite,&kappa,&alpha,&soi,&tm,
		   &condl,&mid);
  fclose(paramfile);

  smodel=pmodel2smodel(model,aaRmat,nchar);

  /* simulation or sequence data for info approximation */
  if(tinfo==1) 
    seq = (int *) malloc((size_t) nsim*ntaxa*sizeof(int));
  if(tinfo==2){
    seq=read_seq(seqfile,nchar,1,&ntaxa,&nsim,&names);
    has_names=1;
  }

  /* frequencies */
  fr = (double *) malloc((size_t) nchar*sizeof(double));
  if ((*aaRmat=='\0' && smodel != 0 && smodel != 3) || 
      (*aaRmat!='\0' && model==3)){ 
    for(i = 0; i < nchar; i++) fso=fscanf(frfile,"%lf",&fr[i]);
  }
  if (*aaRmat!='\0' && model==2) *fr=-1;

  /* K for F84, kappa for HKY */
  if(smodel==2 || smodel==8) Qk=&kappa;

  /* Q matrix for GTR */
  if (smodel == 3){
    Qk = (double *) malloc((size_t) nchar*nchar*sizeof(double));
    for(i = 0; i < nchar; i++) 
      for(j = 0; j < nchar; j++) fso=fscanf(Qfile,"%lf",&Qk[i+j*nchar]);
  }

  /* Rate Distribution */
  if (alpha > 0) nrate=ncatG;
  if (nrate==1){ rate=&one; wt=&one; }
  if (nrate > 1){
    rate = (double *) malloc((size_t) nrate*sizeof(double));
    wt = (double *) malloc((size_t) nrate*sizeof(double));
  }
  if (alpha > 0) rate[0]=-alpha;
  if (alpha < 0 && nrate > 1){
    for(i = 0; i < nrate; i++) fso=fscanf(ratefile,"%lf %lf",&rate[i],&wt[i]);
  }

  /* tree */
  if(treefile==NULL && utreecfile==NULL){
    printf("A treefile must be specified\n"); exit(1);}
  if(!has_names)
    names = (char (*)[11]) malloc((size_t) ntaxa*sizeof(*names));
  utreec = (double *) malloc((size_t) 4*(ntaxa-1)*sizeof(double));
  if(utreecfile!=NULL)
    for(i=0; i<ntaxa-1; i++) fso=fscanf(utreecfile,"%lf",&utreec[i]);
  if(treefile!=NULL){
    outreec = (double *) malloc((size_t) 4*(ntaxa-1)*sizeof(double));
    read_treecsnl(treefile,ntaxa,names,utreec,has_names);
    rert(soi,ntaxa,utreec,outreec);
    relab_int(ntaxa,outreec,utreec);
    utreec[2+(ntaxa-2)*4] += utreec[3+(ntaxa-2)*4];
    utreec[3+(ntaxa-2)*4] = 0.0;
  } 
  if(tm>0) utreec[2+(ntaxa-2)*4]=tm;

  pr=pr_corrtop_smodel(nchar,smodel,ntaxa,nsite,utreec,nrate,rate,wt,fr,Qk,
		       condl,mid,tinfo,nsim,seq,iseed);
  printf("%.16e\n",pr);
  return(0);
}
