#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>
#ifndef PI
   #define PI 3.14159265358979323846
#endif
enum {
  alanine = 0, arginine, asparagine, aspartic, cysteine, 
  glutamine, glutamic, glycine, histidine, isoleucine,
  leucine, lysine, methionine, phenylalanine, proline,
  serine, threonine, tryptophan, tyrosine, valine
};
#define InverseCDFGamma(prob,alpha,beta) InverseCDFChi2(prob,2.0*(alpha))/(2.0*(beta))
#define SIGN(a,b) ((b) >= 0.0 ? fabs(a) : -fabs(a))
FILE *fopene(char *filename, char *rw, char *err);
char get_param(int *k, char **arg, char *value);
char ctl_paraml(FILE *fp, char *opt, char *value, int *is_option);
int pmodel2smodel(int model, char *aaRmat, int nchar);
void seq_genc(int smodel, int ntaxa, double *utreec, int nsite, int *seq, 
	      int nrate, double alpha, int iseed, double *fr, double *Qk);
void pr_splits(FILE *outfile, int numsp, int nspl, int *splits);
void pr_usplits(FILE *outfile, int nspl, int numsp, int *usplits, int *count);
void split_leading1(int numsp, int *split);
void utreec2splits(int numsp, double *utreec, int *splits);
double dim_split(int numsp, int ntrees);
int ivsame(int n, int *x, int *y);
void backward_prob(int nchar, int ntaxa, int l, int *s, double *M, double *f, 
		   double *b);
void ocalc(int nchar, double *M, double *b, double *o);
void backward_probs(int nchar, int ntaxa, int *s, double *utreec, double *M, 
		    double *f, double *b, int deriv);
void forward_prob(int nchar, int ntaxa, int k, int r, int *s, double *M, 
		  double *fr, double *f);
void forward_probs(int nchar, int ntaxa, int *s, double *utreec, double *M, 
		   double *f);
 void lik_deriv_calc(int nchar, int ntaxa, int *s, double *fr, double *utreec, 
		     double *Mp, double *f, double *b, double *lp);
double lik_deriv_site_1rate(int nchar, int ntaxa, int *s, double *fr, 
			    double *utreec, double *M, double *Mp, double *lp,
			    int deriv);
double lik_deriv_site(int nchar, int ntaxa, int *s, double *fr, double *utreec, 
		      int nrate, double *rate, double *wt, 
		      double *M, double *Mp, double *lp, int deriv);
double ederiv(int nchar, int ntaxa, int *s, double *fr, double *utreec,  
	    double *M, double *Mp, int e);
double emderiv(int nchar, int ntaxa, int *s, double *fr, double *utreec, 
	       double *M, double *Mp, double *d, double *dm);
double infomx3(int nchar, int ntaxa, int *s, double *fr, double *utreec, 
	       int nrate, double *wt, double *M, double *Mp, double *l2);
double escorex3(int nchar, int ntaxa, int *s, double *fr, double *utreec, 
	       int nrate, double *wt, double *M, double *Mp, double *l1);
void infomatrixf3(int nchar, int ntaxa,double *fr, double *utreec, int nrate,
		  double *wt, double *M, double *Mp, double *Mm, 
		  double *infom, int mid);
void infomatrixf3_patt(int nchar, int ntaxa,double *fr, double *utreec, 
		       int nrate, double *wt,
		       double *M, double *Mp, double *infom, 
		       int nsite, int npattf, int *patt, int *count);
void escoref3(int nchar, int ntaxa,double *fr, double *utreec, int nrate,
		  double *wt, double *M, double *Mp, double *Mm, 
		  double *escore, int mid);
void escoref3_patt(int nchar, int ntaxa,double *fr, double *utreec, int nrate,
		   double *wt, double *M, double *Mp, 
		   double *escore,  int nsite, int npattf, int *patt, 
		   int *count);
void infomatrixscore_gen(int nchar, int ntaxa, double *utreec, int nrate, 
			 double *rate, double *wt, 		      
			 double pij(int i, int j, double t, int nchar, 
				    double *fr, double *W, double *Lam),
			 double ppij(int i, int j, double t, int nchar, 
				     double *fr, double *W, double *Lam),
			 double *fr, double *W, double *Lam, double *infom, 
			 double *escore, int mid);
void infomatrix_gen_patt(int nchar, int ntaxa, double *utreec,  
			 int nrate, double *rate, double *wt, 		      
			 double pij(int i, int j, double t, int nchar, 
				    double *fr, double *W, double *Lam),
			 double ppij(int i, int j, double t, int nchar, 
				     double *fr, double *W, double *Lam),
			 double *fr, double *W, double *Lam, double *infom, 
			 int nsite, int npatt, int *patt, int *count);
void infomatrixscore_gen_patt(int nchar, int ntaxa, double *utreec,  
			      int nrate, double *rate, double *wt, 
			      double pij(int i, int j, double t, int nchar, 
					 double *fr, double *W, double *Lam),
			      double ppij(int i, int j, double t, int nchar, 
					  double *fr, double *W, double *Lam),
			      double *fr, double *W, double *Lam, double *infom,
			      double *escore,
			      int nsite, int npatt, int *patt, int *count);
void infomatrix_gen(int nchar, int ntaxa, double *utreec,  
		    int nrate, double *rate, double *wt, 		      
		    double pij(int i, int j, double t, int nchar, 
			       double *fr, double *W, double *Lam),
		    double ppij(int i, int j, double t, int nchar, 
				double *fr, double *W, double *Lam),
		    double *fr, double *W, double *Lam, double *infom);
void covscorecor(int ntaxa, double *infom, double *Sc);
void covscorecore(int ntaxa, double *infom, double *escore, double *Sc, 
		  double *Ec);
void corscorecor(int ntaxa, double *infom, double *Sc, double *Ic);
void corscorecore(int ntaxa, double *infom, double *escore, double *Sc, 
		  double *Ec, double *Ic);
void deltaxa(int ntaxa, char *taxon, char names[][11], double *utreec);
void pr4design_paramf(FILE *fp, FILE **utreecfile, FILE **treefile, 
		      FILE **frfile, FILE **Qfile, FILE **ratefile, 
		      FILE **seqfile, char *aaRmat, int *ntaxa, 
		      int *nchar, int *model, int *ncatG, int *nrate, 
		      int *tinfo, int *nsim, int *iseed, int *nsite, 
		      double *kappa, double *alpha, int *soi, double *tm,
		      int *condl, int *mid);
void pr_short_name(FILE *fp, char *name);
void pr_name_split(FILE *fp, int ntaxa, char names[][11], int *split);
double pr_corrtop(int ntaxa, int nsite, double tm, double *infom, 
		  double *escore, int mid, int condl);
double pr_corrtop_gen(int nchar, int ntaxa, int nsite, double *utreec,
		      int nrate, double *rate, double *wt, 
		      double pij(int i, int j, double t, int nchar, 
				 double *fr, double *W, double *Lam),
		      double ppij(int i, int j, double t, int nchar, 
				  double *fr, double *W, double *Lam),
		      double *fr, double *W, double *Lam, int condl, int mid,
		      int tinfo, int nsim, int *seq, int iseed, int smodel, 
		      double *Qk);
double pr_corrtop_smodel(int nchar, int smodel, int ntaxa, int nsite, 
			 double *utreec, int nrate, double *rate, double *wt, 
			 double *fr, double *Qk, int condl, int mid,
			 int tinfo, int nsim, int *seq, int iseed);
void pr_corrtop_mutreec(int nchar, int ntaxa, int nsite, int ntree,
			int nrate, double *rate, double *wt,
			double *utrees, double *p, int condl, int mid);
void pr_corrtop_mn(int nchar, int ntaxa, int *nsite, double *utreec, 
		   int nrate, double *rate, double *wt,  
		   int nn, double *pn, int condl, int mid);
void makeprotfreqs(double *fr, double *W, double *Lam);
void Mijp(double t, double *fr, double *W, double *Lam, double *f);
void Mijpd(double t, double *fr, double *W, double *Lam, double *M, double *Mp, 
	   double *Mpp);
void Mijpd_gam(double t, double *fr, double *W, double *Lam, 
	       double *M, double *Mp, double *Mpp, double alpha);
void WLamfr2exchange(int nchar, double *W, double *Lam, double *fr, double *R);
void chQ_freq(int nbin, double *W, double *Lam, double *fr, double *fro);
double int_elamrt(double t, double lam, double alpha, int deriv, double *de);
double pijJCg(int x, int y, double t, int nchar);
double pijJCg_gen(int x, int y, double t, int nchar, double *fr, double *W, 
		  double *Lam);
double ppijJCg(int x, int y, double t, int nchar);
double ppijJCg_gen(int x, int y, double t, int nchar, double *fr,
		   double *W, double *Lam);
double pp2ijJCg(int x, int y, double t, int nchar);
void pJCm(double t, int nchar, double *fr, int deriv, 
	    double *M, double *Mp, double *Mpp);
void pJCm_gen(double t, int nchar, double *fr, double *W, double *Lam, 
		int deriv, double *M, double *Mp, double *Mpp);
void pJCma(double t, int nchar, double *fr, int deriv, double alpha,
	   double *M, double *Mp, double *Mpp);
void pJCma_gen(double t, int nchar, double *fr, double *W, double *Lam, 
	       int deriv, double alpha, double *M, double *Mp, double *Mpp);
double muF81f(int nchar, double *fr);
double pijF81(int i, int j, double t, int nchar, double mu, double *fr);
double pijF81_gen(int i, int j, double t, int nchar, double *fr, double *mu,
		  double *Lam);
double ppijF81(int i, int j, double t, int nchar, double mu, double *fr);
double ppijF81_gen(int i, int j, double t, int nchar, double *fr, double *mu,
		   double *Lam);
void pF81m(double t, int nchar, double *fr, double mu, int deriv, 
	   double *M, double *Mp, double *Mpp);
void pF81m_gen(double t, int nchar, double *fr, double *mu, double *Lam, 
		 int deriv, double *M, double *Mp, double *Mpp);
void pF81ma(double t, int nchar, double *fr, double mu, int deriv, double alpha,
	   double *M, double *Mp, double *Mpp);
void pF81ma_gen(double t, int nchar, double *fr, double *mu, double *Lam, 
		int deriv, double alpha, double *M, double *Mp, double *Mpp);
int is_transitionf(int i, int j);
double muF84f(double K, double *fr);
double pijF84(int i, int j, double t, double mu, double K, double *fr);
double pijF84_gen(int i, int j, double t, int nchar, double *fr, double *mu,
		  double *K);
double ppijF84(int i, int j, double t, double mu, double K, double *fr);
double ppijF84_gen(int i, int j, double t, int nchar, double *fr, double *mu,
		  double *K);
double p2ijF84(int i, int j, double t, double mu, double K, double *fr);
double p2ijF84_gen(int i, int j, double t, int nchar, double *fr, double *mu,
		  double *K);
void pF84m(double t, double mu, double K, double *fr, int deriv, 
	   double *M, double *Mp, double *Mpp);
void pF84m_gen(double t, int nchar, double *fr, double *mu, double *K, 
	       int deriv, double *M, double *Mp, double *Mpp);
void pF84ma(double t, double mu, double K, double *fr, int deriv, double alpha,
	    double *M, double *Mp, double *Mpp);
void pF84ma_gen(double t, int nchar, double *fr, double *mu, double *K, 
		int deriv, double alpha, double *M, double *Mp, double *Mpp);
double tt2K(double R, double *fr);
double K2tt(double K, double *fr);
double muHKYf(double kappa, double *fr);
double pijHKY(int i, int j, double t, double mu, double kappa, double *fr);
double pijHKY_gen(int i, int j, double t, int nchar, double *fr, double *mu,
		  double *kappa);
double ppijHKY(int i, int j, double t, double mu, double kappa, double *fr);
double ppijHKY_gen(int i, int j, double t, int nchar, double *fr, double *mu,
		   double *kappa);
double p2ijHKY(int i, int j, double t, double mu, double kappa, double *fr);
double p2ijHKY_gen(int i, int j, double t, int nchar, double *fr, double *mu,
		   double *kappa);
void pHKYm(double t, int nchar, double *fr, double mu, double kappa,
	   int deriv, double *M, double *Mp, double *Mpp);
void pHKYm_gen(double t, int nchar, double *fr, double *mu, double *kappa, 
	       int deriv, double *M, double *Mp, double *Mpp);
void pHKYma(double t, int nchar, double *fr, double mu, double kappa,
	    int deriv, double alpha, double *M, double *Mp, double *Mpp);
void pHKYma_gen(double t, int nchar, double *fr, double *mu, double *kappa, 
	       int deriv, double alpha, double *M, double *Mp, double *Mpp);
double tt2kappa(double R, double *fr);
double kappa2tt(double kappa,  double *fr);
void rmnegpv(int m, double *pv, int incp);
void rmnegtrans(int m, double *P);
void Q2frWLam(int nbin, double *Q, double *fr, double *W, double *Lam);
double pijGTR(int i, int j, double t, int nchar, double *fr, double *W, 
	      double *Lam);
double ppijGTR(int i, int j, double t, int nchar, double *fr, double *W, 
	       double *Lam);
double p2ijGTR(int i, int j, double t, int nchar, double *fr, double *W, 
	       double *Lam);
void pGTRm(double t, int nchar, double *fr, double *W, double *Lam, 
	   int deriv, double *M, double *Mp, double *Mpp);
void pGTRma(double t, int nchar, double *fr, double *W, double *Lam, 
	    int deriv, double alpha, double *M, double *Mp, double *Mpp);
int subst_model_setp(int smodel,
		     double (*(*pij))(int i, int j, double t, int nchar,
				     double *fr, double *W, double *Lam),
		     double (*(*ppij))(int i, int j, double t, int nchar,
				       double *fr, double *W, double *Lam));
int subst_model_setpm(int smodel,
		      void (*(*pm))(double t, int nchar, double *fr, 
				    double *W, double *Lam, int deriv, 
				    double *M, double *Mp, 
				    double *Mpp));
int subst_model_setpma(int smodel,
		       void (*(*pm))(double t, int nchar, double *fr, 
				     double *W, double *Lam, int deriv, 
				     double alpha,
				     double *M, double *Mp, double *Mpp));
int subst_model_setparam(int nchar, int smodel, double *fr, double *Qk,
			 double **W, double **Lam);
int subst_model_set(int nchar, int smodel, double *fr, double *Qk, 
		    double (*(*pij))(int i, int j, double t, int nchar, 
				     double *fr, double *W, double *Lam),
		    double (*(*ppij))(int i, int j, double t, int nchar, 
				      double *fr, double *W, double *Lam),
		    double **W, double **Lam);
int subst_model_setm(int nchar, int smodel, double *fr, double *Qk, 
		     void (*(*pm))(double t, int nchar, double *fr, 
				   double *W, double *Lam, int deriv, 
				   double *M, double *Mp, 
				   double *Mpp),
		     double **W, double **Lam);
void trans_gen(int nchar, int ntaxa, double *utreec, double *fr, double *W, 
	       double *Lam, 		      
	       double pij(int i, int j, double t, int nchar, 
			  double *fr, double *W, double *Lam),
	       double ppij(int i, int j, double t, int nchar, 
			     double *fr, double *W, double *Lam),
	       double *M, double *Mp);
void trans_gen_rate(int nchar, int ntaxa, double *utreec, 
		    int nrate, double *rate, double *wt,
		    double *fr, double *W, double *Lam, 		      
		    double pij(int i, int j, double t, int nchar, 
			       double *fr, double *W, double *Lam),
		    double ppij(int i, int j, double t, int nchar, 
				double *fr, double *W, double *Lam),
		    double *M, double *Mp);
void transm_rate(int smodel, int nchar, int ntaxa, double *utreec, 
		 int nrate, double *rate, double alpha,
		 double *fr, double *W, double *Lam, int deriv, 
		 double *M, double *Mp, double *Mpp);
int l2i(char c);
char i2l(int i);
char i2lp(int i);
int l2ip(char c);
void rmgap(int numsp, int *nsite, char *seqc);
int rmgap_pair(int nsite, int *s1, int *s2, int *seq1, int *seq2);
int rseqf(FILE *fp, char *seq);
char ignore_whitespace_seqfile(FILE *infile);
int rinterleave_block(FILE *infile, int numsp, int nsite, char name[][11], 
		       char *seq, int *initb);
void rinterleavef_nolim(FILE *infile, const int *numsp, const int *nsite, 
			char name[][11], char *seq);
void rinterleave(int *numsp, int *nsite, char name[][11], char *seq);
void rinterleavef(FILE *infile, int *numsp, int *nsite, char name[][11], 
		  char *seq);
void letter(int numsp, int nsite, char *seq);
void pchar_freq(int nchar, int nsite, int *s1, int *s2, double *pf);
int pchar_freqi(int nchar, int nsite, int *s1, int *s2, int *nxy);
void char_freq(int nchar, int numsp, int nsite, int *seq, double *freq);
void char_freq_count(int nchar, int numsp, int endsite, int *seq, int *count, 
		     double *freq);
int patt_freq(int numsp, int nsite, int *seq, int *count);
int patt_freq_locs(int numsp, int nsite, int *seq, int *count, int *locs);
int all_sitepatt(int nchar, int ntaxa, int *patt);
int all_sitepattr(int nchar, int ntaxa, int *patt);
void pr_utreec_top(FILE *fp, int ntaxa, int *utreec);
void rlord_utreec(int ntaxa, double *utreec);
void utreec2bl(int ntaxa, double *utreec, double *bl);
void bl2utreec(int ntaxa, double *bl, double *utreec);
void pr_distmat(FILE *fp, int numsp, char name[][11], double *dmat);
void infilefreq(int nbin, int ntaxa, int nsite, int *seq, double *freq);
char *read_seqc(FILE *fp, int *ntaxa, int *nsite, char (**name)[11]);
int *read_seq(FILE *fp, int nchar, int rm_gap, int *ntaxa, int *nsite, 
	      char (**name)[11]);
int names_infile(FILE *infile, char (**names)[11], int sequential);
void parent_branch(int r, int ntaxa, double *utreec, int *p, int *l, 
		   double *bl, double *br);
void relab_int(int ntaxa, double *utreec, double *nutreec);
void rert(int r, int ntaxa, double *utreec, double *nutreec);
int sp_char(char c);
void ch_name(int lstring, char *tstring, int i);
int has_bl(char *tstring);
void ch_labels_nbl(int ntaxa, char *tstring, char names[][11]);
void ch_labels(int ntaxa, char *tstring, char names[][11]);
int is_wsp(char c);
void rmblntree(char *tstring, int rwsp);
int read_tree(FILE *fp, char *tstring);
double get_dlist(char *tstr, int ss, int de, int *ssn, int *ls, int *le);
void underscore2blank(char *s);
char **treecs(int ntaxa, char *tstr, char names[][11], double *utreec, 
	      int has_names);
void treecsnl(int ntaxa, char *tstr, char names[][11], double *utreec, 
	      int has_names);
char **read_treecs(FILE *treefile, int ntaxa, char names[][11], double *utreec, 
		   int has_names);
void read_treecsnl(FILE *treefile, int ntaxa, char names[][11], double *utreec, 
		   int has_names);
void rmexspce(int numsp, char names[][11]);
int ndig_intpart(double f);
char *ut2in(int numsp, double *utreec, char names[][11], char **ilabels);
void ut2n(int numsp, double *utreec, char names[][11], char *tstr);
void ut2nt(int numsp, double *utreec, char names[][11], char *tstr);
int icomp(const int *a, const int *b);
void isort(int n, int *x);
double dot(int n, double *u, int incu, double *v, int incv);
int chol(int m, double *l);
void cholf(int m, double *l, double *b);
void cholh(int m, double *l, double *b);
int choltr(int m, double *l);
int lstring(char * string);
int eigenRealSym(double A[], int n, double Root[], double Offdiag[]);
void EigenSort(double d[], double U[], int n);
void HouseholderRealSym(double a[], int n, double d[], double e[]);
int EigenTridagQLImplicit(double d[], double e[], int n, double z[]);
int DiscreteGamma (double freqK[], double rK[], double alpha, double beta, int K, int dgammamean);
void error2 (char * message);
long factorial (int n);
double LnGamma (double x);
double InverseCDFNormal (double prob);
double InverseCDFChi2 (double prob, double v);
double IncompleteGamma (double x, double alpha, double ln_gamma_alpha);
