#include "pr4f.h"
int main(int argc, char **argv)
{
  FILE *treefile,*outtreefile;
  char (*names)[11],**alabels,*tstr;
  int ntaxa,i,*splits;
  double *utreec;

  if(argc!=4){
    printf("pr4list needs 3 arguments: number of taxa, treefile and outtreefile\n");
    exit(1);
  }

  outtreefile=fopen(argv[--argc],"w");
  treefile=fopen(argv[--argc],"r");
  ntaxa=atoi(argv[--argc]);

  names = (char (*)[11]) malloc((size_t) ntaxa*sizeof(*names));
  utreec = (double *) malloc((size_t) 4*(ntaxa-1)*sizeof(double));
  alabels = (char **) malloc((size_t) (ntaxa-2)*sizeof(char *));
  for(i = 0; i < ntaxa-2; i++)
    alabels[i]=(char *) malloc((size_t) 4*sizeof(char *));
  splits = (int *) malloc((size_t) ntaxa*(ntaxa-3)*sizeof(int));
  
  read_treecsnl(treefile,ntaxa,names,utreec,0);
  for(i=0; i<ntaxa; i++) printf("%s\n",names[i]);
  /* pr_utreec(stdout,ntaxa,utreec); */
  
  for(i = 0; i < ntaxa-3; i++){
    sprintf(alabels[i],"%i",i+ntaxa);
  }
  alabels[ntaxa-3][0]='\0';

  tstr=ut2in(ntaxa,utreec,names,alabels);
  fprintf(outtreefile,"%s\n",tstr);
  
  utreec2splits(ntaxa,utreec,splits);
  for(i=0; i<ntaxa; i++)
    printf("Split %i: %s from rest\n",i,names[i]);
  for(i=0; i<ntaxa-3; i++){
    printf("\nSplit %i\n",i+ntaxa);
    pr_name_split(stdout,ntaxa,names,&splits[i*ntaxa]);
  }
  return(0);
}
